#!/usr/bin/python
#
# called by the cnd-program line in mgetty.config just before it answers the phone
# In fact, it's asking for permission to answer the phone, so make sure there
# are no errors generated by this script or mgetty won't answer the phone!

# 1) formats the cid info for use as log entry and file name
# 2) pops up a dialog with caller-id to X desktop which optionally opens voxpak
#
# args sent to us are:
# <program> <tty> <CallerID> <Name> <dist-ring-nr.> <Called Nr.>
# Thu Jan 11 23:44:57 2001 pevans@catholic.org

import os, sys, string, pwd, re
from sys import argv

#debian and rh systems name mgetty dir differently
f = os.popen('ls /etc | grep mgetty', 'r')
vcfgfile = "/etc/" + string.replace(f.read(), '\n', '') + "/voice.conf"
f.close

try:
    f = open(vcfgfile, 'r')
    vconf = f.readlines()
    f.close()
    for line in vconf:
        if re.match('^phone_owner',line):
            USER = string.strip(line[12:])
            break
    for line in vconf:
        if re.match('^phone_group',line):
            GRP = string.strip(line[12:])
            break
except IOError:
    USER = os.environ['USER']
    GRP = 'uucp'

#### You could set this to your user name
#### *if* you don't like the default user it's pulling
#### from your voice.conf above
# USER = 'yourname'
# GRP = 'yourgroup'

GRPID = pwd.getpwnam(GRP)[3]
USERID = pwd.getpwnam(USER)[2]
HOMEDIR = '/home/' + USER
os.putenv('HOME',HOMEDIR)
os.environ['USER'] = USER
os.setregid(GRPID, GRPID) 
os.setreuid(USERID, USERID)

try:
    tty = argv[1]   # modem device we're responding to
except:
    tty = 'notty'
try:
    cid = argv[2]   # 'phone number'
    cid = cid[:-7] + '-' + cid[-7:-4] + '-' + cid[-4:]
except:
    cid = ''
try:
    name = string.capwords(argv[3])  #capitalize first letter, lower the rest
    name = string.replace(name, ' ', '_')      # change any spaces to underscores
    name = string.replace(name, '&', '-')      # change any ampersands to dashes
    name = string.replace(name, 'none', '')    # squeeze out 'none' for those without cid
except:
    name = 'Unknown'

# ringtype = argv[4] # For distinctive ring

# callednumber = argv[5] # only good for ISDN (or a DID trunk I imagine)

import time
# strftime uses the same format as the bash date command
stamp = time.strftime('%Y-%m-%d-%a-%H%M', time.localtime(time.time() ) )

# make a string for When Who called from Where
cidinfo =  stamp+'_'+name+'_'+cid


try:
    f = open(HOMEDIR + '/voice_mail.log', 'r')
    orig = f.read()
    f.close()
except IOError:
    orig = ""

outstr = orig + cidinfo + '\n'

f = open(HOMEDIR + '/voice_mail.log', 'w')
f.write(outstr)
f.close()

f = open("/tmp/cid.txt", 'w') # make a file for message_program to read later
f.write(cidinfo + '\n')       # *if* caller actually leaves a message
f.close()                     # message_program will use it to rename the file


os.putenv('DISPLAY',':0.0') # Don't need to *allow* root to open on your display by issuing
                            # an 'xhost +localhost', because of os.setuid(USERID) above


os.system('/usr/bin/killall -9 gdialog 2>&1 >/dev/null')
cmd = '/usr/bin/nohup ' + HOMEDIR + '/bin/voxask.sh ' + cidinfo +'&' #pop up a dialog on X desktop
os.system(cmd)


